// SettingsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VidzRadioProdTest.h"
#include "SettingsDlg.h"
#include "ColorStaticST.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSettingsDlg dialog


CSettingsDlg::CSettingsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSettingsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSettingsDlg)
	//}}AFX_DATA_INIT
	// Initialize class variables
	m_uiPresetFreq	= 0;
	m_uiSenStaFreq1	= 0;
	m_uiSenStaFreq2 = 0;
	m_uiSenStaFreq3 = 0;
	m_uiSrFrequency	= 0;
	m_uiSrDirection	= 0;
	m_uiRemoteChoice= 0;
	m_bAutoTest		= FALSE;
	m_bEnableSound	= FALSE;
	m_bEnableRC		= FALSE;
}


void CSettingsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSettingsDlg)
	DDX_Control(pDX, IDC_ENRC, m_cbnEnableRC);
	DDX_Control(pDX, IDC_ENSOUND, m_cbnEnableSound);
	DDX_Control(pDX, IDC_AUTOTEST, m_cbnAutoTest);
	DDX_Control(pDX, IDC_RC_CHOICE, m_cbRemoteChoice);
	DDX_Control(pDX, IDC_SR_DRTN, m_cbSrDirection);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSettingsDlg, CDialog)
	//{{AFX_MSG_MAP(CSettingsDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSettingsDlg message handlers

BOOL CSettingsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	if(m_uiPresetFreq != 0)
		UpdateSettingsDlg();
	else
	{
		SetDlgItemText(IDC_PRESET_FREQ, "93.30");
		SetDlgItemText(IDC_SENSTA1, "88.30");
		SetDlgItemText(IDC_SENSTA2, "95.00");
		SetDlgItemText(IDC_SENSTA3, "100.30");
		SetDlgItemText(IDC_SR_FREQ, "98.00");
		m_cbSrDirection.SetCurSel(0);
		m_cbRemoteChoice.SetCurSel(0);
		SetDlgItemText(IDC_CUR_FIRMWARE_VER, "1.3");
		m_cbnAutoTest.SetCheck(0);
		m_cbnEnableSound.SetCheck(0);
		m_cbnEnableRC.SetCheck(0);
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CSettingsDlg::OnOK() 
{
	CString		csPresetFreq, csSenSta1, csSenSta2, csSenSta3, csSrFreq, csFirmVer;
	INT			find;

	// Store preset frequencies into class variables
	GetDlgItemText(IDC_PRESET_FREQ, csPresetFreq);
	GetDlgItemText(IDC_SENSTA1, csSenSta1);
	GetDlgItemText(IDC_SENSTA2, csSenSta2);
	GetDlgItemText(IDC_SENSTA3, csSenSta3);
	GetDlgItemText(IDC_SR_FREQ, csSrFreq);
	find = csPresetFreq.Find('.');
	// Checking for format error
	if(csPresetFreq.Find('.') == -1 || csSenSta1.Find('.') == -1 || csSenSta2.Find('.') == -1
		|| csSenSta3.Find('.') == -1 || csSrFreq.Find('.') == -1)
	{
		DisplayErrMsg("Frequency entered not in correct format.\nExample: 93.30, 98.70, 100.30.");
		return;
	}
	else if(csPresetFreq.Remove('.') != 1 || csSenSta1.Remove('.') != 1 
			|| csSenSta2.Remove('.') != 1 || csSenSta3.Remove('.') != 1 
			|| csSrFreq.Remove('.') != 1)
		{
			DisplayErrMsg("Frequency entered not in correct format.\nExample: 93.30, 98.70, 100.30.");
			return;
		}
		else
		{
			m_uiPresetFreq = atoi(csPresetFreq);
			m_uiSenStaFreq1 = atoi(csSenSta1);
			m_uiSenStaFreq2 = atoi(csSenSta2);
			m_uiSenStaFreq3 = atoi(csSenSta3);
			m_uiSrFrequency = atoi(csSrFreq);
			// Checking for range error
			if(m_uiPresetFreq < 8700 || m_uiPresetFreq > 10800 || m_uiSenStaFreq1 < 8700 
				|| m_uiSenStaFreq1 > 10800 || m_uiSenStaFreq2 < 8700 || m_uiSenStaFreq2 > 10800
				|| m_uiSenStaFreq3 < 8700 || m_uiSenStaFreq3 > 10800 || m_uiSrFrequency < 8700
				|| m_uiSrFrequency > 10800)
			{
				DisplayErrMsg("Please enter frequency within range of 87 - 108 Mhz.\nPlease ensure format of frequency is correct.");
				return;
			}
		}

	// Storing combo box choices into class variables
	m_uiSrDirection		= m_cbSrDirection.GetCurSel();
	m_uiRemoteChoice	= m_cbRemoteChoice.GetCurSel();

	// Process firmware version editbox
	GetDlgItemText(IDC_CUR_FIRMWARE_VER, csFirmVer);
	if(csFirmVer.Find('.') == -1 || csFirmVer.Remove('.') != 1)
	{
		DisplayErrMsg("Please enter firmware version in following format.\nExample: 1.1, 2.0");
		return;
	}
	else
		m_uiCurFirmVer = atoi(csFirmVer);
			
	// Test if the check boxes are checked and store result in class variables
	if(m_cbnAutoTest.GetState() & 0x0003)
		m_bAutoTest = TRUE;
	else
		m_bAutoTest = FALSE;
	
	if(m_cbnEnableSound.GetState() & 0x0003)
		m_bEnableSound = TRUE;
	else
		m_bEnableSound = FALSE;

	if(m_cbnEnableRC.GetState() & 0x0003)
		m_bEnableRC = TRUE;
	else
		m_bEnableRC = FALSE;

	CDialog::OnOK();
}

void CSettingsDlg::DisplayErrMsg(CString csErrMsg)
{
	MessageBox(csErrMsg, "Error Message", MB_OK|MB_ICONEXCLAMATION);
}

void CSettingsDlg::UpdateSettingsDlg()
{
	CString csDisplay;
		
	// Load default preset test frequency
	csDisplay.Format("%d", m_uiPresetFreq);
	csDisplay.Insert((csDisplay.GetLength()-2), '.');
	SetDlgItemText(IDC_PRESET_FREQ, csDisplay);
		
	// Load frequencies for sensitivity test
	// Load frequency for 1st frequency
	csDisplay.Format("%d", m_uiSenStaFreq1);
	csDisplay.Insert((csDisplay.GetLength()-2), '.');
	SetDlgItemText(IDC_SENSTA1, csDisplay);
	// Load frequency for 2nd frequency
	csDisplay.Format("%d", m_uiSenStaFreq2);
	csDisplay.Insert((csDisplay.GetLength()-2), '.');
	SetDlgItemText(IDC_SENSTA2, csDisplay);
	// Load frequency for 3rd frequency
	csDisplay.Format("%d", m_uiSenStaFreq3);
	csDisplay.Insert((csDisplay.GetLength()-2), '.');
	SetDlgItemText(IDC_SENSTA3, csDisplay);
		
	// Load the default search starting frequency
	csDisplay.Format("%d", m_uiSrFrequency);
	csDisplay.Insert((csDisplay.GetLength()-2), '.');
	SetDlgItemText(IDC_SR_FREQ, csDisplay);
	// Show the default searching direction
	m_cbSrDirection.SetCurSel(m_uiSrDirection);

	// Show the default remote control button
	m_cbRemoteChoice.SetCurSel(m_uiRemoteChoice);

	// Show the default current firmware version
	csDisplay.Format("%d", m_uiCurFirmVer);
	csDisplay.Insert((csDisplay.GetLength()-1), '.');
	SetDlgItemText(IDC_CUR_FIRMWARE_VER, csDisplay);

	// Show the default misc options choices
	m_cbnAutoTest.SetCheck(m_bAutoTest);
	m_cbnEnableSound.SetCheck(m_bEnableSound);
	m_cbnEnableRC.SetCheck(m_bEnableRC);
}
